import { CacheProvider as DefaultCacheProvider } from "@emotion/react";
import wrappedWithAppEmotionCache from "./withAppEmotionCache";
import wrappedAugmentDocumentWithEmotionCache from "./augmentDocumentWithEmotionCache";
/**
 * @see <https://docs.tss-react.dev/ssr/next.js>
 * This utility implements https://emotion.sh/docs/ssr#advanced-approach
 * */
export function createEmotionSsrAdvancedApproach(
/** This is the options passed to createCache() from 'import createCache from "@emotion/cache"' */
options, 
/** By default <CacheProvider /> from 'import { CacheProvider } from "@emotion/react"' */
CacheProvider = DefaultCacheProvider) {
    const withAppEmotionCache = wrappedWithAppEmotionCache(options, CacheProvider);
    const augmentDocumentWithEmotionCache = wrappedAugmentDocumentWithEmotionCache(options);
    return { withAppEmotionCache, augmentDocumentWithEmotionCache };
}
