"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEmotionSsrAdvancedApproach = void 0;
const react_1 = require("@emotion/react");
const withAppEmotionCache_1 = __importDefault(require("./withAppEmotionCache"));
const augmentDocumentWithEmotionCache_1 = __importDefault(require("./augmentDocumentWithEmotionCache"));
/**
 * @see <https://docs.tss-react.dev/ssr/next.js>
 * This utility implements https://emotion.sh/docs/ssr#advanced-approach
 * */
function createEmotionSsrAdvancedApproach(
/** This is the options passed to createCache() from 'import createCache from "@emotion/cache"' */
options, 
/** By default <CacheProvider /> from 'import { CacheProvider } from "@emotion/react"' */
CacheProvider = react_1.CacheProvider) {
    const withAppEmotionCache = (0, withAppEmotionCache_1.default)(options, CacheProvider);
    const augmentDocumentWithEmotionCache = (0, augmentDocumentWithEmotionCache_1.default)(options);
    return { withAppEmotionCache, augmentDocumentWithEmotionCache };
}
exports.createEmotionSsrAdvancedApproach = createEmotionSsrAdvancedApproach;
